/*
 * gc global variable provides access to GUI Composer infrastructure components and project information.
 * For more information, please see the Working with Javascript guide in the online help.
 */
var gc = gc || {};
gc.services = gc.services || {};
var saveAsFilePath; // undefined initially
var regFileFormat = "CSV";
var lambda = 243.12;
var beta = 17.62;
var firstConnectFlag = 0;



/*    
gc.autoDetectPortIdentity = function(port, helperAPI) {
    if (port.productId !== 769) {
            return;
    }
    return helperAPI.serialPortConnect().then(function() {
        var controllerName = "usb2any";
        var u2a = helperAPI.createPacketCodec(controllerName);
        var model = document.querySelector('ti_model_register');
        return model.scanForDevice(u2a, controllerName)
        }).finally(function() {
            helperAPI.serialPortDisconnect(helperAPI);
        });
};*/

var convertTemp = function(value, isToCelsius) {
    var result = value;
    if (isToCelsius) {
        result = (value - 32) / 1.8;
    } else {
        result = (value * 1.8) + 32;
    }
    return Number.parseFloat(result).toFixed(3);
};

var convertOffsetTemp = function(value, isToCelsius) {
    var result = value;
    if (isToCelsius) {
        result = (value) / 1.8;
    } else {
        result = (value * 1.8);
    }
    return Number.parseFloat(result).toFixed(3);
};

var getF = function(value){
	return (value * 1.8) + 32;
};
var getC = function(value){
    return (value - 32) / 1.8;
};

var tempScale = "C";        // Holds current temperature Scale
var sampleNumber = 100;     // Holds current number of samples to plot
var sampleIndex = 0;        // Current Index of Sample to be placed in array
var sampleTimeArray = [];   // Array for time-samples

var saveText = function(fname, text) {
    var blob = new Blob([text], {
        type: 'text/plain;charset=utf-8'
    });
    saveAs(blob, fname);

    return false;
};

function convertTimestamp(timestamp) {
    var d = new Date(timestamp), // Convert the passed timestamp to milliseconds
        yyyy = d.getFullYear(),
        mm = ('0' + (d.getMonth() + 1)).slice(-2); // Months are zero based. Add leading 0.
        dd = ('0' + d.getDate()).slice(-2); // Add leading 0.
        hh = d.getHours();
        h = hh;
        min = ('0' + d.getMinutes()).slice(-2); // Add leading 0.
        sec= ('0' + d.getSeconds()).slice(-2); // Add leading 0.
        msec= ('0' + d.getMilliseconds()).slice(-3); // Add leading 0.
        //ampm = 'AM',
        var time;

    time = +h + ':' + min + ':' + sec + '.' + msec + ' ';// + ',' + yyyy + '-' + mm + '-' + dd;
    return time;
}

var getHex8 = function(value) {
    // convert the register value into a human readable format for the GUI and convert to F if needed
    var result = gc.utils.getHexString(value, 8, "0x");
    return result;
};


//stream to file code - Currently unused because of Engineers's request for file header
/********************************Start Of File Stream Code********************************************/
var mystream;
var mywriter;
var myTextEnc = new TextEncoder();
var saveStart = function(filename) {
	if (!filename) filename = 'mydata.csv';
	mystream = streamSaver.createWriteStream(filename);
	saveAbort();
	mywriter = mystream.getWriter();
	saveData(myTextEnc.encode('Time,Temperature (' + tempScale + '),Humidity (%)\n'));
};
var saveStop = function() {
	if (mywriter) {
		mywriter.close();
		mywriter = null;
	}
};
var saveAbort = function() {
	if (mywriter){
		mywriter.abort('reason');
		mywriter = null;
	}
};
var saveData = function(data) {
	if (mywriter) {
		mywriter.write(data);
	}
};
window.addEventListener('unload', (event) => {
	//  console.log('unload', event);
	saveAbort(); // seems ok but please test.
});
var saveDummyData = function() {
	// To save textual data use TextEncoder to encode the data first
	var my_text = 'abcdef 01234 ABCDEF 56789 some text to go ... done';
	var myary = myTextEnc.encode(my_text + '\n');
	saveData(myary);
	// To save byte array data like below, no need to encode it.
	//saveData([1,2,3,4,5,6,7,8,9,10, 100,101]);  
};
/********************************End Of File Stream Code**********************************************/

/*
 *  Boilerplate code for creating computed data bindings
 */
document.addEventListener('gc-databind-ready', function() {
    /*
     *   Add custom computed value databindings here, using the following method:
     *
     *   function gc.databind.registry.bind(targetBinding, modelBinding, [getter], [setter]);
     *
     *   param targetBinding - single binding string or expression, or array of binding strings for multi-way binding.
     *   param modelBinding - single binding string or expression, or array of binding strings for multi-way binding.
     *   param getter - (optional) - custom getter function for computing the targetBinding value(s) based on modelBinding value(s).
     *   param setter - (optional) - custom setter function for computing the modelBinding value(s) based on targetBinding value(s).
     */
	
	// Bind Red LED to Heater bit
	gc.databind.registry.bind('ti_model_register.u2a.gpio.REDLED','ti_model_register.CONFIG.HEAT_EN');

    /******************************************** Start Data Collection Page Bindings *************************************************/
	//Databinding for Series 0 on Scalar Graph, including conversion handling and timestamp recording
    gc.databind.registry.bind('ti_widget_scalargraph.value_0', 'ti_model_register.TEMP_LOW.TEMP_LOW',
        function(value){
           var temphivalue =  gc.databind.registry.getBinding('ti_model_register.TEMP_HIGH.TEMP_HIGH').getValue();
           value += (temphivalue * 256);
           value = ((value * 165) / 65536) - 40;
           var timestamp = new Date();
            if(sampleIndex < sampleNumber )
            {
                sampleTimeArray.push(timestamp);
                sampleIndex += 1;
            }
            else
            {
                sampleTimeArray.shift();
                sampleTimeArray.push(timestamp);
            }
            
            var humhivalue =  gc.databind.registry.getBinding('ti_model_register.HUM_HIGH.HUM_HIGH').getValue();
            var humlowvalue = gc.databind.registry.getBinding('ti_model_register.HUM_LOW.HUM_LOW').getValue();
            
            humlowvalue = (humhivalue * 256) + humlowvalue;
            humlowvalue = (humlowvalue / 65536) * 100;
            
            if (tempScale === "C")
            {
                saveData(myTextEnc.encode(convertTimestamp(timestamp) + ',' + value + ',' + humlowvalue + '\n'));
                return value; // Number.parseFloat(value).toFixed(3);
            }
            else
            {
                saveData(myTextEnc.encode(convertTimestamp(timestamp) + ',' + getF(value) + ',' + humlowvalue + '\n'));
                return getF(value); //Number.parseFloat(getF(value).toFixed(3));
            }
        });
        
        //binding of auto-read on data capture tab to register page tab
	gc.databind.registry.bind('ti_widget_droplist_auto_read.selectedIndex', "ti_widget_register_page.autoReadValue", 
		function(value){                                // Getter function, sets drop list based on autoReadValue changes
			switch(Number(value)){
			case -1: //Auto read is off
				return 0;
			case 0: // As Fast as possible
				return 1;
			case 200: // 200ms delay
				return 2;
			case 500: // 500mS delay
				return 3;
			case 1000: // 1S delay
				return 4;
			case 5000: // 5S delay
				return 5;
			case 10000: // 10S delay
				return 6;
			case 60000: // 60S delay
				return 7;
			case 120000: // 120S delay
				return 8;
			default:
				return 4;
			}
		},
		function(value){                                // Setter function, sets autoReadValue based on droplist chnages
			switch(Number(value)){
			case 0: //Auto read is off
				return -1;
			case 1: // As Fast as possible
				return 0;
			case 2: // 200ms delay
				return 200;
			case 3: // 500mS delay
				return 500;
			case 4: // 1S delay
				return 1000;
			case 5: // 5S delay
				return 5000;
			case 6: // 10S delay
				return 10000;
			case 7: // 60S delay
				return 60000;
			case 8: // 120S delay
				return 120000;
			default:
				return 1000;
			}
		});
        
    
    //Databinding for Series 1 on Scalar Graph, including conversion handling
    gc.databind.registry.bind('ti_widget_scalargraph.value_1', 'ti_model_register.HUM_LOW.HUM_LOW',
        function(value){
            var humhivalue =  gc.databind.registry.getBinding('ti_model_register.HUM_HIGH.HUM_HIGH').getValue();
            value = (humhivalue * 256) + value;
            value = (value / 65536) * 100;

            return value; // Number.parseFloat(value).toFixed(3);
        });
        
    //Temperature Result conversion
    gc.databind.registry.bind('widget.ti_widget_label_tempPlot.label','ti_model_register.TEMP_LOW.TEMP_LOW',
        function(value) {
            var temphivalue =  gc.databind.registry.getBinding('ti_model_register.TEMP_HIGH.TEMP_HIGH').getValue();
            value = (temphivalue * 256) + value;
            value = ((value * 165) / 65536) - 40;
            if (tempScale === "C")
				return Number.parseFloat(value).toFixed(3);
			else 
				return Number.parseFloat(getF(value)).toFixed(3);
        }
    );
    
    //Humidity Result conversion
    gc.databind.registry.bind('widget.ti_widget_label_humPlot.label','ti_model_register.HUM_LOW.HUM_LOW',
        function(value) {
            var humhivalue =  gc.databind.registry.getBinding('ti_model_register.HUM_HIGH.HUM_HIGH').getValue();
            value = (humhivalue * 256) + value;
            value = (value / 65536) * 100;
            
            //set Humidity Label
			return Number.parseFloat(value).toFixed(3);
        }
    );        
    
    //Dew Point Label
    gc.databind.registry.bind('widget.ti_widget_label_dewPoint.label','ti_model_register.HUM_LOW.HUM_LOW',
        function(value) {
            //Need humidity value to calculate dewpoint - not in %
            var humhivalue =  gc.databind.registry.getBinding('ti_model_register.HUM_HIGH.HUM_HIGH').getValue();
            value = (humhivalue * 256) + value;
            value = (value / 65536);
            //need temp to calculate dew point
            var tempLowByte = gc.databind.registry.getBinding('ti_model_register.TEMP_LOW.TEMP_LOW').getValue();
            var tempHighByte = gc.databind.registry.getBinding('ti_model_register.TEMP_HIGH.TEMP_HIGH').getValue();
            var temp = (tempHighByte * 256) + tempLowByte;
            temp = ((temp * 165) / 65536) - 40;
            
            //Pws
            var pws = 6.116441 * Math.pow(10, (7.591386 * temp/(temp + 240.7263)));
            
            var pw = pws * value;
            
            //set dew Point Label
            //var dewPoint = lambda * (Math.log(value) + (beta * temp)/(lambda + temp));
            //dewPoint = dewPoint/(beta - Math.log(value) + (beta * temp)/(lambda + temp));
            
            var dewPoint = 240.7263/((7.591386)/(Math.log10(pw/6.116441))-1);
            
            if (tempScale === "C")
			    return Number.parseFloat(dewPoint).toFixed(3);
			else 
				return Number.parseFloat(getF(dewPoint)).toFixed(3);
        }
    );
    
    
    //Enthalpy Label
    gc.databind.registry.bind('widget.ti_widget_label_enthalpy.label','ti_model_register.HUM_LOW.HUM_LOW',
        function(value) {
            //Need humidity value to calculate dewpoint - not in %
            var humhivalue =  gc.databind.registry.getBinding('ti_model_register.HUM_HIGH.HUM_HIGH').getValue();
            value = (humhivalue * 256) + value;
            value = (value / 65536);
            //need temp to calculate dew point
            var tempLowByte = gc.databind.registry.getBinding('ti_model_register.TEMP_LOW.TEMP_LOW').getValue();
            var tempHighByte = gc.databind.registry.getBinding('ti_model_register.TEMP_HIGH.TEMP_HIGH').getValue();
            var temp = (tempHighByte * 256) + tempLowByte;
            temp = ((temp * 165) / 65536) - 40;
            

            //Pws
            var pws = 6.116441 * Math.pow(10, (7.591386 * temp/(temp + 240.7263)));
            
            var pw = pws * value;
            
            //Mixing Ratio
            var chi = 621.9907*pw/(1013-pw);
            
            //calculate enthalpy
            var h = temp*(1.01 + 0.00189*chi) + 2.5 * chi;
            
            return Number.parseFloat(h).toFixed(3);
        }
    );
    
    //Heat Index Label
    gc.databind.registry.bind('widget.ti_widget_label_heatIndex.label','ti_model_register.HUM_LOW.HUM_LOW',
        function(value) {
            //Need humidity value to calculate dewpoint - not in %
            var humhivalue =  gc.databind.registry.getBinding('ti_model_register.HUM_HIGH.HUM_HIGH').getValue();
            value = (humhivalue * 256) + value;
            value = (value / 65536);
            
            //need temp to calculate dew point
            var tempLowByte = gc.databind.registry.getBinding('ti_model_register.TEMP_LOW.TEMP_LOW').getValue();
            var tempHighByte = gc.databind.registry.getBinding('ti_model_register.TEMP_HIGH.TEMP_HIGH').getValue();
            var temp = (tempHighByte * 256) + tempLowByte;
            temp = ((temp * 165) / 65536) - 40;
            
            //set Heat Index Label
            var heatIndex = 0.363445186 + 0.988622465 * temp + 4.777114035 * value - 0.114037667 * temp * value;
            heatIndex+= -8.50208e-4 * Math.pow(temp, 2) - 2.0716198e-2 * Math.pow(value, 2) + 6.87678e-4 * Math.pow(temp, 2) * value;
            heatIndex+= 2.74954e-4 * temp * Math.pow(value,2);
            //var heatIndex = 16.923 + 0.185212 * temp + 5.37941 * value -0.100254 * temp * value + .00941695 * Math.pow(temp, 2);
            //heatIndex += 0.00728898 * Math.pow(value, 2) + 0.00034572 * Math.pow(temp, 2) * value - 0.000814971 * temp * Math.pow(value, 2);
            //heatIndex += 1.02102E-5 * Math.pow(value*temp, 2) - 3.8646e-5*Math.pow(temp, 3) * 2.91583e-5*Math.pow(value, 3) + 1.42721e-6 * Math.pow(temp, 3)*value;
            //heatIndex += 1.97483e-7 * temp * Math.pow(value, 3) - 2.18429e-8 * Math.pow(value*temp, 2) * temp;
            //heatIndex += 8.43296e-10 * Math.pow(value*temp, 2)*value -4.18975e-11 * Math.pow(value*temp, 3);
            
            if (tempScale === "C")
			    return Number.parseFloat(heatIndex).toFixed(3);
			else 
				return Number.parseFloat(getF(heatIndex)).toFixed(3);
        }
    );
    
    //Absolute Humidity Label
    gc.databind.registry.bind('widget.ti_widget_label_absHum.label','ti_model_register.HUM_LOW.HUM_LOW',
        function(value) {
            //Need humidity value to calculate absolute humidity - not in
            var humhivalue =  gc.databind.registry.getBinding('ti_model_register.HUM_HIGH.HUM_HIGH').getValue();
            value = (humhivalue * 256) + value;
            value = (value / 65536)*100;
            
            //need temp to calculate absolute humidity
            var tempLowByte = gc.databind.registry.getBinding('ti_model_register.TEMP_LOW.TEMP_LOW').getValue();
            var tempHighByte = gc.databind.registry.getBinding('ti_model_register.TEMP_HIGH.TEMP_HIGH').getValue();
            var temp = (tempHighByte * 256) + tempLowByte;
            temp = ((temp * 165) / 65536) - 40;
            
            //set absolute humidity label
            var absHumidity = (6.112 * Math.exp(17.67*temp/(temp + 243.5)) * value * 2.1674)/(273.15 + temp);
            
			return Number.parseFloat(absHumidity).toFixed(3);
        }
    );
    
    //Bind temp scale radio groups between config page and data capture tab
    gc.databind.registry.bind('widget.ti_widget_radio_group_tempScaleConfig.selectedText','widget.ti_widget_radio_group_tempScale.selectedText',
        //Set plot page based on config page
        function(value)
        {
			return value;
        },
        //set config page based on plot page
        function(value)
        {
            return value;
            
        }
    );        
    
    //Widget to Widget binding for graph scaling mode 
    gc.databind.registry.bind('widget.ti_widget_scalargraph.fixedScale','widget.ti_widget_droplist_scaleMode.selectedValue');
    gc.databind.registry.bind('widget.ti_widget_scalargraph.fixedScale','widget.ti_widget_droplist_scaleMode1.selectedValue'); 
    //Widget to Widget binding for graph Temp Max
    gc.databind.registry.bind('widget.ti_widget_scalargraph.series_0_max','widget.ti_widget_spinner_tempScaleMax.value');
    gc.databind.registry.bind('widget.ti_widget_scalargraph.series_0_max','widget.ti_widget_spinner_tempScaleMax1.value');      
    //Widget to Widget binding for graph Temp Min
    gc.databind.registry.bind('widget.ti_widget_scalargraph.series_0_min','widget.ti_widget_spinner_tempScaleMin.value');
    gc.databind.registry.bind('widget.ti_widget_scalargraph.series_0_min','widget.ti_widget_spinner_tempScaleMin1.value'); 
    //Widget to Widget binding for graph Humidity Max
    gc.databind.registry.bind('widget.ti_widget_scalargraph.series_1_max','widget.ti_widget_spinner_humScaleMax.value'); 
    gc.databind.registry.bind('widget.ti_widget_scalargraph.series_1_max','widget.ti_widget_spinner_humScaleMax1.value');  
    //Widget to Widget binding for graph Humidity Min
    gc.databind.registry.bind('widget.ti_widget_scalargraph.series_1_min','widget.ti_widget_spinner_humScaleMin.value'); 
    gc.databind.registry.bind('widget.ti_widget_scalargraph.series_1_min','widget.ti_widget_spinner_humScaleMin1.value'); 
    //AMM Mode 
    gc.databind.registry.bind('widget.ti_widget_droplist_ammPlot.selectedValue','ti_model_register.CONFIG.AMM');    
    //Temperature Resolution 
    gc.databind.registry.bind('widget.ti_widget_droplist_tempResPlot.selectedValue','ti_model_register.MEAS_CONFIG.TRES');
    //Humidity Resolution 
    gc.databind.registry.bind('widget.ti_widget_droplist_humResPlot.selectedValue','ti_model_register.MEAS_CONFIG.HRES');
    //Measurement Configuration 
    gc.databind.registry.bind('widget.ti_widget_droplist_measConfigPlot.selectedValue','ti_model_register.MEAS_CONFIG.MEAS_CONF');     
        
    /******************************************** End Data Collection Page Bindings *************************************************/
        
    //Manufacturer ID Word
	gc.databind.registry.bind('widget.ti_widget_label_manIDLow.label', 'ti_model_register.MANUF_ID_LOW.MANF_ID_LOW',function(value) {
            //Get High byte and concatenate
            var manIdHigh =  gc.databind.registry.getBinding('ti_model_register.MANUF_ID_HIGH.MANF_ID_HIGH').getValue();
            value = (manIdHigh * 256) + value;
            
            var result = gc.utils.getHexString(value, 8, "");
            return result;
            
        });
	gc.databind.registry.bind('widget.ti_widget_label_manIDHigh.label', 'ti_model_register.MANUF_ID_HIGH.MANF_ID_HIGH',getHex8);

    //Dev ID Word
	gc.databind.registry.bind('widget.ti_widget_label_devIDLow.label', 'ti_model_register.DEVID_LOW.DEVID_LOW',function(value) {
            //Get High byte and concatenate
            //var devIdHigh =  gc.databind.registry.getBinding('ti_model_register.DEVID_HIGH.DEVID_HIGH').getValue();
            //value = (devIdHigh * 256) + value;
            
            var result = gc.utils.getHexString(value, 8, "");
            return result;
            
        });
	gc.databind.registry.bind('widget.ti_widget_label_devIDHigh.label', 'ti_model_register.DEVID_HIGH.DEVID_HIGH',getHex8);

    /******************************************** Start Device Config Page Bindings *************************************************/
    //Humidity Offset conversion
    gc.databind.registry.bind('widget.ti_widget_label_humOffset.label','ti_model_register.HUM_OFFSET.HUM_OS',
        function(value) {
            var FLAG_H_0 = 1;
            var FLAG_H_1 = 2;
            var FLAG_H_2 = 4;
            var FLAG_H_3 = 8;
            var FLAG_H_4 = 16;
            var FLAG_H_5 = 32;
            var FLAG_H_6 = 64;
            var FLAG_H_7 = 128;
            var humoffset = 0;
            if(value & FLAG_H_7) {
                humoffset += -25;
            }
            if(value & FLAG_H_6) {
                humoffset += 12.5;
            }
            if(value & FLAG_H_5) {
                humoffset += 6.3;
            }
            if(value & FLAG_H_4) {
                humoffset += 3.1;
            }
            if(value & FLAG_H_3) {
                humoffset += 1.6;
            }
            if(value & FLAG_H_2) {
                humoffset += 0.8;
            }
            if(value & FLAG_H_1) {
                humoffset += 0.4;
            }
            if(value & FLAG_H_0) {
                humoffset += 0.2;
            }
			return Number.parseFloat(humoffset).toFixed(1);
        });
        
    //Temp Offset conversion
    gc.databind.registry.bind('widget.ti_widget_label_tempOffset.label','ti_model_register.TEMP_OFFSET.TEMP_OS',
        function(value) {
            var FLAG_T_0 = 1;
            var FLAG_T_1 = 2;
            var FLAG_T_2 = 4;
            var FLAG_T_3 = 8;
            var FLAG_T_4 = 16;
            var FLAG_T_5 = 32;
            var FLAG_T_6 = 64;
            var FLAG_T_7 = 128;
            var tempoffset = 0;
            if(value & FLAG_T_7) {
                tempoffset += -20.62;
            }
            if(value & FLAG_T_6) {
                tempoffset += 10.32;
            }
            if(value & FLAG_T_5) {
                tempoffset += 5.16;
            }
            if(value & FLAG_T_4) {
                tempoffset += 2.58;
            }
            if(value & FLAG_T_3) {
                tempoffset += 1.28;
            }
            if(value & FLAG_T_2) {
                tempoffset += 0.64;
            }
            if(value & FLAG_T_1) {
                tempoffset += 0.32;
            }
            if(value & FLAG_T_0) {
                tempoffset += 0.16;
            }
            
            if (tempScale === "C")
                return Number.parseFloat(tempoffset).toFixed(3);
            else
               return getF(Number.parseFloat(tempoffset).toFixed(3)) - 32; //Since this is offset, do not include 32 offset between C and F
        });
        
        
        
    //Temperature High Threshold
    gc.databind.registry.bind('widget.ti_widget_label_tempThresholdHighLabel.label','ti_model_register.TEMP_THRES_HIGH.TEMP_THRES_HIGH',
        function(value) {
            value = ((value * 165) / 256) - 40;
            
            if (tempScale === "C")
				return Number.parseFloat(value).toFixed(3);
			else 
				return Number.parseFloat(getF(value)).toFixed(3);
        }
    );
    
    //Temperature Low Threshold
    gc.databind.registry.bind('widget.ti_widget_label_tempThresholdLowLabel.label','ti_model_register.TEMP_THRES_LOW.TEMP_THRES_LOW',
        function(value) {
            value = ((value * 165) / 256) - 40;
            
            if (tempScale === "C")
				return Number.parseFloat(value).toFixed(3);
			else 
				return Number.parseFloat(getF(value)).toFixed(3);
        }
    );
    
    //Humidity Low Threshold
    gc.databind.registry.bind('widget.ti_widget_label_humThresholdLow.label','ti_model_register.HUM_THRES_LOW.HUM_THRES_LOW',
        function(value) {
            value = (value / 256) * 100;
			return Number.parseFloat(value).toFixed(3);
        }
    );
    
    //Humidity High Threshold
    gc.databind.registry.bind('widget.ti_widget_label_humThresholdHigh.label','ti_model_register.HUM_THRES_HIGH.HUM_THRES_HIGH',
        function(value) {
            value = (value / 256) * 100;
			return Number.parseFloat(value).toFixed(3);
        }
    );
    
    //Temperature Result conversion for config page
    gc.databind.registry.bind('widget.ti_widget_label_tempConfig.label','ti_model_register.TEMP_LOW.TEMP_LOW',
        function(value) {
            var temphivalue =  gc.databind.registry.getBinding('ti_model_register.TEMP_HIGH.TEMP_HIGH').getValue();
            value = (temphivalue * 256) + value;
            value = ((value * 165) / 65536) - 40;
            if (tempScale === "C")
				return Number.parseFloat(value).toFixed(3);
			else 
				return Number.parseFloat(getF(value)).toFixed(3);
        }
    );
    
    //Humidity Result conversion for config page
    gc.databind.registry.bind('widget.ti_widget_label_humConfig.label','ti_model_register.HUM_LOW.HUM_LOW',
        function(value) {
            var humhivalue =  gc.databind.registry.getBinding('ti_model_register.HUM_HIGH.HUM_HIGH').getValue();
            value = (humhivalue * 256) + value;
            value = (value / 65536) * 100;
            
            //set Humidity Label
			return Number.parseFloat(value).toFixed(3);
        }
    );  
    
    //Temperature Max Label
    gc.databind.registry.bind('widget.ti_widget_label_tempMax.label','ti_model_register.TEMP_MAX.TEMP_MAX',
        function(value) {
            value = ((value * 165) / 256) - 40;
            
            if (tempScale === "C")
				return Number.parseFloat(value).toFixed(3);
			else 
				return Number.parseFloat(getF(value)).toFixed(3);
        }
    );
    
    //Humidity Max Label
    gc.databind.registry.bind('widget.ti_widget_label_humMax.label','ti_model_register.HUM_MAX.HUM_MAX',
        function(value) {
            value = (value / 256) * 100;
			return Number.parseFloat(value).toFixed(3);
        }
    );

    //AMM Mode 
    gc.databind.registry.bind('widget.ti_widget_droplist_ammConfig.selectedValue','ti_model_register.CONFIG.AMM');    
    //Temperature Resolution 
    gc.databind.registry.bind('widget.ti_widget_droplist_tempResConfig.selectedValue','ti_model_register.MEAS_CONFIG.TRES');
    //Humidity Resolution 
    gc.databind.registry.bind('widget.ti_widget_droplist_humResConfig.selectedValue','ti_model_register.MEAS_CONFIG.HRES');
    //Measurement Configuration 
    gc.databind.registry.bind('widget.ti_widget_droplist_measConfigPage.selectedValue','ti_model_register.MEAS_CONFIG.MEAS_CONF');
    //Interrupt Enable
    gc.databind.registry.bind('widget.ti_widget_droplist_intPinConfig.selectedValue','ti_model_register.CONFIG.DRDY_INT_EN');    
    //Interrupt Polarity
    gc.databind.registry.bind('widget.ti_widget_droplist_intPol.selectedValue','ti_model_register.CONFIG.INT_POL');
    //Interrupt Mode
    gc.databind.registry.bind('widget.ti_widget_droplist_InterruptMode.selectedValue','ti_model_register.CONFIG.INT_MODE');
    //DRDY Enable
    gc.databind.registry.bind('widget.ti_widget_checkbox_DRDY.checked','ti_model_register.INT_CONFIG.DRDY_EN');
    //High Temperature Threshold Enable
    gc.databind.registry.bind('widget.ti_widget_checkbox_tempHighThreshold.checked','ti_model_register.INT_CONFIG.TH_EN');
    //Low Temperature Threshold Enable
    gc.databind.registry.bind('widget.ti_widget_checkbox_tempLowThreshold.checked','ti_model_register.INT_CONFIG.TL_EN');
    //High Humidity Threshold Enable
    gc.databind.registry.bind('widget.ti_widget_checkbox_humHighThreshold.checked','ti_model_register.INT_CONFIG.HH_EN');
    //Low Humidity Threshold Enable
    gc.databind.registry.bind('widget.ti_widget_checkbox_humLowThreshold.checked','ti_model_register.INT_CONFIG.HL_EN');
    //Humidity Offset Widget
    gc.databind.registry.bind('widget.ti_widget_spinner_humOffset.value','ti_model_register.HUM_OFFSET.HUM_OS');
    //Humidity High Threshold
    gc.databind.registry.bind('widget.ti_widget_spinner_humThresholdHigh.value','ti_model_register.HUM_THRES_HIGH.HUM_THRES_HIGH');
    //Humidity Low Threshold
    gc.databind.registry.bind('widget.ti_widget_spinner_humThresholdLow.value','ti_model_register.HUM_THRES_LOW.HUM_THRES_LOW');
    //Temp Offset
    gc.databind.registry.bind('widget.ti_widget_spinner_tempOffset.value','ti_model_register.TEMP_OFFSET.TEMP_OS');
    //Temp High Threshold
    gc.databind.registry.bind('widget.ti_widget_spinner_tempThresholdHigh.value','ti_model_register.TEMP_THRES_HIGH.TEMP_THRES_HIGH');
    //Temp Low Threshold
    gc.databind.registry.bind('widget.ti_widget_spinner_tempThresholdLow.value','ti_model_register.TEMP_THRES_LOW.TEMP_THRES_LOW');
    
    /******************************************** End Device Config Page Bindings *************************************************/
    
});

/*
 *  Boilerplate code for creating custom actions
 */
document.addEventListener('gc-nav-ready', function() {
    /*
     *   Add custom actions for menu items using the following api:
     *
     *   function gc.nav.registryAction(id, runable, [isAvailable], [isVisible]);
     *
     *   param id - uniquely identifies the action, and should correspond to the action property of the menuaction widget.
     *   param runable - function that performs the custom action.
     *   param isAvailable - (optional) - function called when the menu action is about to appear.  Return false to disable the action, or true to enable it.
     *   param isVisible - (optional) - function called when the menu action is about to appear.  Return false to hide the action, or true to make it visible.
     */

    // For example,
    // gc.nav.registerAction('myCustomCloseAction', function() { window.close(); }, function() { return true; }, function() { return true; });

    // Alternatively, to programmatically disable a menu action at any time use:
    // gc.nav.disableAction('myCustomCloseAction);    then enable it again using:  gc.nav.enableAction('myCustomCloseAction');


    gc.nav.registerAction('show_introduction', function() {
        if ((templateObj) && (templateObj.$)) {
            templateObj.$.ti_widget_vtabcontainer.selectedIndex = 0;
            templateObj.$.ti_widget_menuitem.hideFullMenu();
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });
    gc.nav.registerAction('show_registers', function() {
        if ((templateObj) && (templateObj.$)) {
            templateObj.$.ti_widget_vtabcontainer.selectedIndex = 1;
            templateObj.$.ti_widget_menuitem.hideFullMenu();
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });
    gc.nav.registerAction('show_motor_control', function() {
        if ((templateObj) && (templateObj.$)) {
            templateObj.$.ti_widget_vtabcontainer.selectedIndex = 2;
            templateObj.$.ti_widget_menuitem.hideFullMenu();
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });

    gc.nav.registerAction('set_csv_format', function() {
        regFileFormat = "CSV";
        gc.nav.setActionChecked('set_csv_format', true);
        gc.nav.setActionChecked('set_json_format', false);
    }, function() {
        return  true; // isAvailable
    }, function() {
        return true; // isVisible
    });
    gc.nav.setActionChecked('set_csv_format', true);

    gc.nav.registerAction('set_json_format', function() {
        regFileFormat = "JSON";
        gc.nav.setActionChecked('set_csv_format', false);
        gc.nav.setActionChecked('set_json_format', true);
    }, function() {
        return true; // isAvailable
    }, function() {
        return true;  // isVisible
    });

    var saveText = function(fname, text, mime) {
        var blob = new Blob([text], {
            type: mime
        });
        saveAs(blob, fname);
        return false;
    };

    var getCsvForRegs = function(){
        var result = "register,address,value\n";
        var regPage = document.querySelector('#ti_widget_register_page');
        var regBlocks = regPage && regPage.regBlocks;
        if (regBlocks) {
            for (var b=0; b < regBlocks.length; b++) {
                var regBlock = regBlocks[b];
                for (var r=0; r < regBlock.registers.length; r++) {
                    var reg = regBlock.registers[r];
                    result += reg.name+","+reg.addr+","+reg.value+"\n";
                }
            }
        }
        return result;
    };

    /*
     * saveRegs saves the register values from the register page into either a CSV file 
     * format or a stringified JSON object and saves them to a file.  If isSaveAs
     * parameter is true (or the saveAsFilePath global has not been set), 
     * it shows the 'browseAndSave' dialog to allow the user to 
     * specify which folder to save the file into, otherwise it saves the contents to 
     * the file path specified by saveAsFilePath
     */
    var saveRegs = function(calledBy, isSaveAs) {
        var fileFilter;
        var regData;
        switch (regFileFormat) {
            case "CSV":
                regData = getCsvForRegs();
                fileFilter = ".csv";
                // make sure the file extension matches the regFileFormat
                if (saveAsFilePath) {
                    saveAsFilePath = saveAsFilePath.replace(".json", ".csv");
                }
                break;
            case "JSON":
            default:
                fileFilter = ".json";
                regData = JSON.stringify(templateObj.getRegisterData());
                // make sure the file extension matches the regFileFormat
                if (saveAsFilePath) {
                    saveAsFilePath = saveAsFilePath.replace(".csv", ".json");
                }
        }
        var fileName = saveAsFilePath;
        if (!fileName) {
            fileName = "regs" + fileFilter;
        }
        if (gc.desktop.isDesktop()) {
            if (isSaveAs || !saveAsFilePath ) {
                gc.File.browseAndSave(regData, fileName, fileFilter, function (result, errorInfo) {
                    if (errorInfo) {
                        templateObj.logMsgAndNotify("error", calledBy + " " + errorInfo, false, true);
                    } else if ((result) && (result.localPath)) {
                        saveAsFilePath = result.localPath;
                        gc.nav.enableAction('save_registers');
                        templateObj.$.ti_widget_eventlog_view.log("info", "Registers saved to " + result.localPath);
                    }
                });
            } else {
                gc.File.save(regData, {"localPath": saveAsFilePath}, null, function(errorInfo) {
                    if (errorInfo) {
                        templateObj.logMsgAndNotify("error", "Save Registers As: " + errorInfo, false, true);
                    } else {
                        templateObj.$.ti_widget_eventlog_view.log("info", "Registers saved to " + saveAsFilePath);
                    }
                });
            }
        } else {
            saveText(fileName, regData, 'text/plain;charset=utf-8');
            templateObj.$.ti_widget_eventlog_view.log("info", calledBy+": "+fileName+" file downloaded");
        }
    };

    /*
     * getRegsFromCsv decodes the string passed in as a parameter as the contents of a CSV file
     * and updates the registers in the regBlocks object with the values from the CSV file.
     * NOTE that the target is not updated with these values by this function.  To update the
     * target registers, please call setRegisterData.
     */
    getRegsFromCsv = function(csvContents) {
        var lines = csvContents.split('\n');
        lines.shift(); // discard the title row
        // create a map of the csv values
        var csvMap = new Map();
        for (var i=0; i < lines.length; i++){
            var regInfo = lines[i].split(",");
            var name = regInfo[0].trim().toLowerCase();
            var addr = +regInfo[1];
            var value = +regInfo[2];
            var key = name+"@"+addr;
            csvMap.set(key,value);
        }
        var regPage = document.querySelector('#ti_widget_register_page');
        var regBlocks = regPage && regPage.regBlocks;
        if (regBlocks) {
            for (var b = 0; b < regBlocks.length; b++) {
                var regBlock = regBlocks[b];
                for (var r = 0; r < regBlock.registers.length; r++) {
                    var reg = regBlock.registers[r];
                    var regAdrs = +reg.addr;
                    var regKey = reg.name.trim().toLowerCase() + "@"+regAdrs;
                    if (csvMap.has(regKey)){
                        reg.value = csvMap.get(regKey);
                    }
                }
            }
        }
        return regBlocks;
    };

    gc.nav.registerAction('load_registers', function() {
        if ((templateObj) && (templateObj.$)) {
            gc.File.browseAndLoad(null, {
                bin: false
            }, function(contents, properties) {
                var regData = null;
                try {
                    var fileType =  regFileFormat;
                    var dotIndex = (properties && properties.name) ? properties.name.lastIndexOf(".") : -1;
                    if (dotIndex >= 0 && dotIndex < properties.name.length) {
                        fileType = properties.name.substring(dotIndex + 1).toUpperCase();
                        if (fileType !== "JSON" && fileType !== "CSV") {
                            fileType = regFileFormat;
                        }
                    }
                    switch (fileType) {
                        case "CSV":
                            regData = getRegsFromCsv(contents);
                            break;
                        default:
                        case "JSON":
                            regData = JSON.parse(contents);
                            if (typeof regData === "string") {
                                regData = JSON.parse(regData);
                            }
                            if (regData && regData.data) {
                                regData = regData.data;
                            }
                            break;
                    }
                    if (regData) {
                        if (templateObj.setRegisterData(regData)) {
                            templateObj.$.ti_widget_eventlog_view.log("info", "Load Registers: loaded from :" + properties.localPath);
                        }
                    }
                } catch (ex) {
                    templateObj.logMsgAndNotify("error", "Load Registers: Could not parse " + regFileFormat + " file:" + ex, false, true);
                }

            });
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });

    gc.nav.registerAction('save_registers', function() {
        if ((templateObj) && (templateObj.$)) {
            saveRegs("Save Registers", false);
        }
    }, function() {
        return saveAsFilePath;  // isAvailable
    }, function() {
        return saveAsFilePath;  // isVisible
    });
    gc.nav.disableAction('save_registers');
    gc.nav.registerAction('save_registers_as', function() {
        if ((templateObj) && (templateObj.$)) {
            saveRegs("Save Registers As", true);
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });

    gc.nav.registerAction('open_log_pane', function() {
        if ((templateObj) && (templateObj.$)) {
            templateObj.$.ti_widget_eventlog_view.openView();
        }
    }, function() {
        return true;
    }, function() {
        return true;
    });

    gc.nav.registerAction('open_scripting_window', function() {
        window.open('app/scripting.html', '_evm_scripting');
    }, function() {
        return true;
    }, function() {
        return true;
    });
});

/*
 *  Boilerplate code for working with components in the application gist
 */


var initComplete = false;
var templateObj;
var registerModel;


// Wait for DOMContentLoaded event before trying to access the application template
var init = function() {
    templateObj = document.querySelector('#template_obj');

    // Wait for the template to fire a dom-change event to indicate that it has been 'stamped'
    // before trying to access components in the application.
    templateObj.addEventListener('dom-change', function() {
        if (initComplete) return;
        this.async(function() {
            initComplete = true;
            console.log("Application template has been stamped.");
            templateObj.$.ti_widget_toast.hideToast();
            templateObj.$.ti_widget_eventlog_view.log("info", "Application started.");
            gc.nav.registerChecklistActions('fileFormat.', fileFormat,
                {
                    onSelectionHandler: function(formatName, detail) {
                        regFileFormat = formatName;
                        gc.localStorage.setItem('fileFormat', formatName);
                    },

                    onIsAvailableHandler: function() {
                        return false;
                    }
                }
                , gc.localStorage.getItem('fileFormat') || regFileFormat, false);
            registerModel = Polymer.dom(document).querySelector('ti-model-register');
            if (registerModel) {
                registerModel.addEventListener("usbHidModelReceivingData", function (event) {
                    templateObj.logMsgAndNotify("debug", "Receiving data from target.", false, false);
                });
            } else {
                console.log("no ti-model-register component found in this application!")
            }

            // Now that the template has been stamped, you can use 'automatic node finding' $ syntax to access widgets.
            // e.g. to access a widget with an id of 'widget_id' you can use templateObj.$.widgetId

            // open the eventlog viewer when the user clicks on the book icon in the status bar:
            templateObj.$.ti_widget_eventlog_view.closeView(); // ensure that view states are in sync with application
            templateObj.$.ti_widget_statusbar.addEventListener("status-icon-clicked", function(event) {
                // TODO: add whatever actions you wish to perform in response to the appStatusIcon in the statusbar
                // being clicked.  See event.details for info on the icon and app status
            });
            
            
    /******************************************** Start Custom Event Listeners *************************************************/
            //Set I2C Frequency based on droplist
            templateObj.$.ti_widget_droplist_I2CFreq.addEventListener("selected", function(event) {
                    
        
                var u2a= document.querySelector('ti-model-register').getCodec();         // get codec
                var Cmd_I2C_Set = 1;                                                     // Command to set I2C port
                var speed = templateObj.$.ti_widget_droplist_I2CFreq.selectedIndex;    // Speed based on droplist index: 0:100kHz, 1:400kHz, 2:10kHz
                var commandSent = u2a.sendCommandPacket(Cmd_I2C_Set, [speed, 0, 1])      // send command to set I2C, see packet definition in USB2ANY.h
            });
            
            
            //Update Temp Scale
            templateObj.$.ti_widget_radio_group_tempScale.addEventListener("changed",function(event) {
               var newScale = templateObj.$.ti_widget_radio_group_tempScale.selectedText;

               if (newScale === "Celsius"){
                    newScale = "C";
               }
               else
                    newScale = "F";
               
               if (newScale !== tempScale)
               {
                    templateObj.$.ti_widget_scalargraph.reset(); //reset scalar graph
                    sampleTimeArray = []; //reset time array
                    sampleIndex = 0; //reset sample index
                    templateObj.$.ti_widget_label_tempPlotLabelScale.label = newScale; //update labels
                    templateObj.$.ti_widget_label_dewPointScale.label = newScale;
                    templateObj.$.ti_widget_label_heatIndexScale.label = newScale;
                    templateObj.$.ti_widget_label_tempConfigLabelScale.label = newScale;
                    templateObj.$.ti_widget_label_tempMaxLabelScale.label = newScale;
                    templateObj.$.ti_widget_label_tempOffsetLabelScale.label = newScale;
                    templateObj.$.ti_widget_label_tempThresholdHighLabelScale.label = newScale;
                    templateObj.$.ti_widget_label_tempThresholdLowLabelScale.label = newScale;
                    templateObj.$.ti_widget_scalargraph.series_0_units = newScale;
                    
                    var isCelsius = (newScale === "C")
                    //Set the offset, threshold, and temperature register labels accordingly
                    templateObj.$.ti_widget_label_tempOffset.label = convertOffsetTemp(templateObj.$.ti_widget_label_tempOffset.label, isCelsius);
                    templateObj.$.ti_widget_label_tempThresholdHighLabel.label = convertTemp(templateObj.$.ti_widget_label_tempThresholdHighLabel.label, isCelsius);
                    templateObj.$.ti_widget_label_tempThresholdLowLabel.label = convertTemp(templateObj.$.ti_widget_label_tempThresholdLowLabel.label, isCelsius);
                    templateObj.$.ti_widget_label_tempMax.label = convertTemp(templateObj.$.ti_widget_label_tempMax.label, isCelsius);
                    templateObj.$.ti_widget_label_tempPlot.label = convertTemp(templateObj.$.ti_widget_label_tempPlot.label, isCelsius);
                    templateObj.$.ti_widget_label_tempConfig.label = convertTemp(templateObj.$.ti_widget_label_tempConfig.label, isCelsius);
                    //Convert fixed-scale limits to ensure that graph edges are still visible
                    templateObj.$.ti_widget_scalargraph.series_0_max = convertTemp(templateObj.$.ti_widget_scalargraph.series_0_max, isCelsius);
                    templateObj.$.ti_widget_scalargraph.series_0_min = convertTemp(templateObj.$.ti_widget_scalargraph.series_0_min, isCelsius);
                    //templateObj.$.ti_widget_spinner_tempScaleMax.value = convertTemp(templateObj.$.ti_widget_spinner_tempScaleMax.value, isCelsius);
                    templateObj.$.ti_widget_spinner_tempScaleMax1.value = convertTemp(templateObj.$.ti_widget_spinner_tempScaleMax1.value, isCelsius);
                    //templateObj.$.ti_widget_spinner_tempScaleMin.value = convertTemp(templateObj.$.ti_widget_spinner_tempScaleMin.value, isCelsius);
                    templateObj.$.ti_widget_spinner_tempScaleMin1.value = convertTemp(templateObj.$.ti_widget_spinner_tempScaleMin1.value, isCelsius);

               }
                
                //update temperature scale variable
                tempScale = newScale;
                
            });
            
            //Software reset button on plot tab
            templateObj.$.ti_widget_button_softResetPlot.addEventListener("click", function(event) {
               var bind = gc.databind.registry.getBinding('ti_model_register.CONFIG.SOFT_RES');
               ti_widget_button_oneShotPlot.label = "Trigger Measurement";
               bind.setValue(1);
            }); 
            
            //Software reset button on configuration tab
            templateObj.$.ti_widget_button_softResetConfig.addEventListener("click", function(event) {
               var bind = gc.databind.registry.getBinding('ti_model_register.CONFIG.SOFT_RES');
               ti_widget_button_oneShotPlot.label = "Trigger Measurement";
               ti_widget_button_oneShotConfig.label = "Trigger Measurement";
               bind.setValue(1);
            }); 
            
            
            //Heater Enable button on plot tab
            templateObj.$.ti_widget_button_heaterPlot.addEventListener("click", function(event) {
               var bind = gc.databind.registry.getBinding('ti_model_register.CONFIG.HEAT_EN');
               if(ti_widget_button_heaterPlot.label.toLowerCase() == "activate heater")
               {
                    ti_widget_button_heaterPlot.label = "Deactivate heater";
                    ti_widget_button_heaterConfig.label = "Deactivate heater";
                    bind.setValue(1);
               } 
               else if(ti_widget_button_heaterPlot.label.toLowerCase() == "deactivate heater")
               {
                    ti_widget_button_heaterPlot.label = "Activate heater";
                    ti_widget_button_heaterConfig.label = "Activate heater";
                    bind.setValue(0);
               } 
            });
            
            //Heater Enable button on configuration tab
            templateObj.$.ti_widget_button_heaterConfig.addEventListener("click", function(event) {
               var bind = gc.databind.registry.getBinding('ti_model_register.CONFIG.HEAT_EN');
               if(ti_widget_button_heaterConfig.label.toLowerCase() == "activate heater")
               {
                    ti_widget_button_heaterPlot.label = "Deactivate heater";
                    ti_widget_button_heaterConfig.label = "Deactivate heater";
                    bind.setValue(1);
               } 
               else if(ti_widget_button_heaterConfig.label.toLowerCase() == "deactivate heater")
               {
                    ti_widget_button_heaterPlot.label = "Activate heater";
                    ti_widget_button_heaterConfig.label = "Activate heater";
                    bind.setValue(0);
               } 
            }); 
            
            //One Shot Button on Plot Tab - need a default case
            templateObj.$.ti_widget_button_oneShotPlot.addEventListener("click", function(event) {
			    var bind0 = gc.databind.registry.getBinding('ti_model_register.MEAS_CONFIG.MEAS_TRIG');

			    if(ti_widget_button_oneShotPlot.label.toLowerCase() === "trigger measurement")
			    {
    				bind0.setValue(1);
			    }
                else if(ti_widget_button_oneShotPlot.label.toLowerCase() === "start measurement")
                {
                    ti_widget_button_oneShotPlot.label = "Stop Measurement";
    				bind0.setValue(1);
                } 
                else if(ti_widget_button_oneShotPlot.label.toLowerCase() === "stop measurement")
                {
                    ti_widget_button_oneShotPlot.label = "Trigger Measurement";
				    var bindamm = gc.databind.registry.getBinding('ti_model_register.CONFIG.AMM');
                    bindamm.setValue(0);
                } 
            });
            
            //One shot button on Config Tab
            templateObj.$.ti_widget_button_oneShotConfig.addEventListener("click", function(event) {
			    var bind0 = gc.databind.registry.getBinding('ti_model_register.MEAS_CONFIG.MEAS_TRIG');

			    if(ti_widget_button_oneShotConfig.label.toLowerCase() === "trigger measurement")
			    {
    				bind0.setValue(1);
			    }
                else if(ti_widget_button_oneShotConfig.label.toLowerCase() === "start measurement")
                {
                    ti_widget_button_oneShotConfig.label = "Stop Measurement";
    				bind0.setValue(1);
                } 
                else if(ti_widget_button_oneShotConfig.label.toLowerCase() === "stop measurement")
                {
                    ti_widget_button_oneShotConfig.label = "Trigger Measurement";
				    var bindamm = gc.databind.registry.getBinding('ti_model_register.CONFIG.AMM');
                    bindamm.setValue(0);
                } 
            });
            
            
            //Update the One shot buttons based on the value in the AMM dropdown
            templateObj.updateConfAMMPlot = function() {
				var bind0 = gc.databind.registry.getBinding('ti_model_register.CONFIG.AMM');
                if (ti_widget_droplist_ammPlot.selectedText.toLowerCase() === "one-shot mode") {
                    ti_widget_button_oneShotPlot.label = "Trigger Measurement";
                    ti_widget_button_oneShotConfig.label = "Trigger Measurement";
                    bind0.setValue(0);
                } else if (ti_widget_droplist_ammPlot.selectedText.toLowerCase() === "1/120hz") {
                    ti_widget_button_oneShotPlot.label = "Start Measurement";
                    ti_widget_button_oneShotConfig.label = "Start Measurement";
                    bind0.setValue(1);
                } else if (ti_widget_droplist_ammPlot.selectedText.toLowerCase() === "1/60hz") {
                    ti_widget_button_oneShotPlot.label = "Start Measurement";
                    ti_widget_button_oneShotConfig.label = "Start Measurement";
                    bind0.setValue(2);
                } else if (ti_widget_droplist_ammPlot.selectedText.toLowerCase() === "0.1hz") {
                    ti_widget_button_oneShotPlot.label = "Start Measurement";
                    ti_widget_button_oneShotConfig.label = "Start Measurement";
                    bind0.setValue(3);
                } else if (ti_widget_droplist_ammPlot.selectedText.toLowerCase() === "0.2hz") {
                    ti_widget_button_oneShotPlot.label = "Start Measurement";
                    ti_widget_button_oneShotConfig.label = "Start Measurement";
                    bind0.setValue(4);
                } else if (ti_widget_droplist_ammPlot.selectedText.toLowerCase() === "1hz") {
                    ti_widget_button_oneShotPlot.label = "Start Measurement";
                    ti_widget_button_oneShotConfig.label = "Start Measurement";
                    bind0.setValue(5);
                } else if (ti_widget_droplist_ammPlot.selectedText.toLowerCase() === "2hz") {
                    ti_widget_button_oneShotPlot.label = "Start Measurement";
                    ti_widget_button_oneShotConfig.label = "Start Measurement";
                    bind0.setValue(6);
                } else if (ti_widget_droplist_ammPlot.selectedText.toLowerCase() === "5hz") {
                    ti_widget_button_oneShotPlot.label = "Start Measurement";
                    ti_widget_button_oneShotConfig.label = "Start Measurement";
                    bind0.setValue(7);
                }
            };
            
            templateObj.$.ti_widget_droplist_ammPlot.addEventListener("selected", function(event) {
                templateObj.updateConfAMMPlot();
            });
            
            templateObj.$.ti_widget_droplist_ammConfig.addEventListener("selected", function(event) {
                templateObj.updateConfAMMPlot();
            });
            
            
            //Update Sample number based on plot page droplist.
            templateObj.$.ti_widget_droplist_sampleNumber.addEventListener("selected", function(event) {
                sampleNumber = Number(templateObj.$.ti_widget_droplist_sampleNumber.selectedText)
                ti_widget_scalargraph.bufferLen = sampleNumber;
                sampleTimeArray = [];
                sampleIndex = 0;
            });
            
            //Clear Chart and reset sampleTimeArray
            templateObj.$.ti_widget_button_clearChart.addEventListener("click", function(event) {
                templateObj.$.ti_widget_scalargraph.reset();
                sampleTimeArray = [];
                sampleIndex = 0;
            });
            
            templateObj.$.ti_widget_button_firmware.addEventListener("click", function(event) {
                templateObj.$.ti_widget_label_Firmware.label = templateObj.$.ti_model_register.getCodec().version;
            });
            
            //Save Chart for Scalar Graph - Implement Last
            templateObj.$.ti_widget_button_saveChart.addEventListener("click", function(event) {
                
                //Want to print date of sample data next to heading row, need to define new date to do so.
                var today = new Date();
                var dd = today.getDate();
                var mm = today.getMonth()+1; //January is 0!
                var yyyy = today.getFullYear();
                
                if(dd<10) {
                    dd = '0'+dd
                } 
                
                if(mm<10) {
                    mm = '0'+mm
                } 
                
                today = mm + '/' + dd + '/' + yyyy;
                //End date creation
                
                var commentString = prompt("Please input file comment (optional)");
                //Print Header information for .csv file to result string
				var result = "Log File Comments:," + commentString + "\n";
				result += "HDC2022 Log File\n"; 
				result += "Date," + today + "\n";
				result += "I2C Frequency," + templateObj.$.ti_widget_droplist_I2CFreq.selectedValue + ", kHz\n";
				result += "I2C Address," + templateObj.$.ti_widget_droplist_I2CAddr.selectedText + "\n";
				result += "Sampling Period," + templateObj.$.ti_widget_register_page.autoReadValue + ", mSec\n";
                result += "Config Reg (0x0E), 0x" + gc.databind.registry.getBinding('ti_model_register.CONFIG').getValue().toString(16) + "\n"; // Config Register Value
                result += "Measurement Config Reg (0x0F), 0x" + gc.databind.registry.getBinding('ti_model_register.MEAS_CONFIG').getValue().toString(16) + "\n"; // Config Register Value
                result += "Temperature Offset Register (0x08) value,"+ templateObj.$.ti_widget_label_tempOffset.label + "," + tempScale + "\n";      // Offset Register value
                result += "Temperature Threshold Low (0x0A) Register value ,"+ templateObj.$.ti_widget_label_tempThresholdLowLabel.label + "," + tempScale + "\n";                             // Offset Register value
                result += "Temperature Threshold High Register (0x0B) value,"+ templateObj.$.ti_widget_label_tempThresholdHighLabel.label + "," + tempScale + "\n";                      // Offset Register value
                result += "Humidity Offset Register (0x09) value,"+ templateObj.$.ti_widget_label_humOffset.label + ",% RH" + "\n";                             // Offset Register value
                result += "Humidity Threshold Low Register (0x0C) value,"+ templateObj.$.ti_widget_label_humThresholdLow.label + ",% RH" + "\n";                             // Offset Register value
                result += "Humidity Threshold High Register (0x0D) value,"+ templateObj.$.ti_widget_label_humThresholdHigh.label + ",% RH" + "\n";                      // Offset Register value
                result += "Manufacturer ID," + templateObj.$.ti_widget_label_manIDHigh.label + templateObj.$.ti_widget_label_manIDLow.label + "\n";          // Device ID
                //result += "Manufacturer ID Low Register, 0x"+ templateObj.$.ti_widget_label_manIDLow.label + "\n";          // Device ID
                //result += "Manufacturer ID High Register,"+ templateObj.$.ti_widget_label_manIDHigh.label + "\n";                     // Device ID
                result += "Device ID,"+ templateObj.$.ti_widget_label_devIDHigh.label + templateObj.$.ti_widget_label_devIDLow.label + "\n";  
                //result += "Device ID Low Register, 0x"+ templateObj.$.ti_widget_label_devIDLow.label + "\n";                     // Device ID
                //result += "Device ID High Register,"+ templateObj.$.ti_widget_label_devIDHigh.label + "\n";              // Device ID
                result += "Sample #,Time,Temperature [" + tempScale + "],";  // Label Row for data + Date
                result += "Humidity [% RH]" + "\n"; // Label Row for data + Date
                
                //strData0 holds values from scalar graph for series 0
                var strData0 = templateObj.$.ti_widget_scalargraph.series_0_values;
                var strData1 = templateObj.$.ti_widget_scalargraph.series_1_values;
                for (var i = sampleNumber - sampleIndex; i < sampleNumber; i++) {
                    var timestamp = convertTimestamp(sampleTimeArray[i - (sampleNumber - sampleIndex)]);
                    result = result + (i - (sampleNumber - sampleIndex)) + ',' + timestamp + "," + Number.parseFloat(strData0[i]).toFixed(3) + "," + Number.parseFloat(strData1[i]).toFixed(3) + "\n";
                }
                
                //Save Excel File
                saveText("HDC2022EVMLogData.csv", result);
            });
            
            //Read ID Registers Button
            templateObj.$.ti_widget_button_readID.addEventListener("click", function(event) {
                
                if(gc.connectionManager.status === "disconnected")
                {
                    templateObj.showToastMsg( "error" , "EVM not Connected", 4);
                }
                else 
                {
                   var u2a= document.querySelector('ti-model-register').getCodec();
                   var Cmd_I2C_ReadWithAddress = 100;
                   var devAddr = Number(ti_widget_droplist_I2CAddr.selectedValue)
                    
                    // I2C read with address to ADDR 41, start at lowest device ID reg (0xFC to oxFF)
                   var commandSent = u2a.sendCommandPacket(Cmd_I2C_ReadWithAddress, [ 0, devAddr, 0xFC, 4] );
                   u2a.readResponse(commandSent).then(function(responsePacket) {
                        var payloadLength = responsePacket[2]; //Record Payload Length
                        var payload = responsePacket.slice(8, 8 + payloadLength); // Returned bytes are from position 8 to 8 + Length
                         // Update device ID Label values
                            ti_widget_label_manIDLow.label = gc.utils.getHexString(payload[0], 8, "");
                            ti_widget_label_manIDHigh.label = gc.utils.getHexString(payload[1], 8, "0x");
                            ti_widget_label_devIDLow.label = gc.utils.getHexString(payload[2], 8, "");
                            ti_widget_label_devIDHigh.label = gc.utils.getHexString(payload[3], 8, "0x");
                            templateObj.showToastMsg( "check" , "Device ID Registers Updated", 4);
                    });
                }
            });
            
            //Read Status Register Button
            templateObj.$.ti_widget_button_readStatus.addEventListener("click", function(event) {
                
                if(gc.connectionManager.status === "disconnected")
                {
                    templateObj.showToastMsg( "error" , "EVM not Connected", 4);
                }
                else 
                {
                   var u2a= document.querySelector('ti-model-register').getCodec();
                   var Cmd_I2C_ReadWithAddress = 100;
                   var devAddr = Number(ti_widget_droplist_I2CAddr.selectedValue)
                    
                    // I2C read with address to ADDR 41, register 0x04, 1 byte
                   var commandSent = u2a.sendCommandPacket(Cmd_I2C_ReadWithAddress, [ 0, devAddr, 0x04, 1] );
                   u2a.readResponse(commandSent).then(function(responsePacket) {
                        var payloadLength = responsePacket[2]; //Record Payload Length
                        var payload = responsePacket.slice(8, 8 + payloadLength); // Returned bytes are from position 8 to 8 + Length
                        //update device ID register
                        /*var bind = gc.databind.registry.getBinding('ti_model_register.INT_DRDY');
                        bind.setValue(payLoad);*/
                         
                         // Update device ID Label values
                            ti_widget_led_DRDY.on = (payload & 0x80);
                            ti_widget_led_tempHigh.on = (payload & 0x40);
                            ti_widget_led_tempLow.on = (payload & 0x20);
                            ti_widget_led_humHigh.on = (payload & 0x10);
                            ti_widget_led_humLow.on = (payload & 0x08);
                            templateObj.showToastMsg( "check" , "Status Register Read", 4);
                    });
                }
            });
            
    /******************************************** End Custom Event Listeners ************************************************/


            // Expand vtabcontainer nav bar when user clicks on menu icon or 'Menu' label
            templateObj.toggleMenu = function(event){
                templateObj.$.ti_widget_vtabcontainer.isExpanded = !templateObj.$.ti_widget_vtabcontainer.isExpanded;
            };
            templateObj.$.ti_widget_icon_button_menu.addEventListener('click',templateObj.toggleMenu);
            templateObj.$.ti_widget_label_menu.addEventListener('click',templateObj.toggleMenu);
            var regPage = document.querySelector('#ti_widget_register_page');
            if (regPage) {
                // get the active device name from the register page
                templateObj.$.ti_widget_menubar.productName = regPage.deviceName;

                // called when the user clicks the Write Register button:
                regPage.addEventListener("write_reg", function (event) {
                    var detailsObj = event.detail;
                    templateObj.logMsgAndNotify(detailsObj.statusType, detailsObj.statusMsg, false, true);
                }.bind(this));

                // called when the user clicks the Write All Registers button:
                regPage.addEventListener("write_regs", function (event) {
                    var detailsObj = event.detail;
                    templateObj.logMsgAndNotify(detailsObj.statusType, detailsObj.statusMsg, false, true);
                }.bind(this));

                // called when the user clicks the Read Register button:
                regPage.addEventListener("read_reg", function (event) {
                    var detailsObj = event.detail;
                    templateObj.logMsgAndNotify(detailsObj.statusType, detailsObj.statusMsg, false, true);
                }.bind(this));

                // called when the user clicks the Read All Registers button:
                regPage.addEventListener("read_regs", function (event) {
                    var detailsObj = event.detail;
                    templateObj.logMsgAndNotify(detailsObj.statusType, detailsObj.statusMsg, false, true);
                }.bind(this));

                // called when the user changes the immediate / deferred mode
                regPage.addEventListener("update_mode_changed", function (event) {
                    var detailsObj = event.detail;
                    templateObj.$.ti_widget_eventlog_view.log("info", "request to change update mode to " + detailsObj.mode.label);
                }.bind(this));

                // called when the user changes the auto read refresh rate
                regPage.addEventListener("auto_read_config_changed", function (event) {
                    var detailsObj = event.detail;
                    templateObj.$.ti_widget_eventlog_view.log("info", "request to change automatic read interval to " + detailsObj.autoRead.label);
                }.bind(this));
            }

            var usbHidService = gc.services['ti-service-usbhid'];
            if (usbHidService) {
                usbHidService.addEventListener('usbHidError', function(event) {
                    var detailsObj = event.detail;
                    templateObj.logMsgAndNotify("error", detailsObj.info + ": " + detailsObj.error, false, true);
                })
            }

            templateObj.getRegisterData = function() {
                var regData = {
                    signature: "register-data",
                    data: []
                };
                var regPage = document.querySelector('#ti_widget_register_page');
                var regBlocks = regPage && regPage.regBlocks;
                if (regBlocks) {
                    for (var i = 0; i < regBlocks.length; i++) {
                        var registersData = [];
                        for (var r = 0; r < regBlocks[i].registers.length; r++) {
                            var reg = regBlocks[i].registers[r];
                            var regName = reg.name.toLowerCase();
                            regName = regName.replace(/&/g, "_");
                            var item = {
                                idx: r,
                                id: regName,
                                value: reg.value
                            };
                            registersData.push(item);
                        }
                        regData.data.push(registersData);
                    }
                }
                return regData;
            };

            templateObj.setRegisterData = function(jsonObj) {
                var ok = true;
                var regData = jsonObj;
                var regPage = document.querySelector('#ti_widget_register_page');
                var regBlocks = regPage && regPage._registerView.regBlocks;
                if (regBlocks) {
                    for (var b = 0; b < Math.min(regData.length, regBlocks.length); b++) {
                        var idx = 0;
                        var dRegName = "";
                        var dBlock = regData[b];
                        var dNumRegs = dBlock.length;
                        if (dBlock.registers) {
                            dNumRegs = dBlock.registers.length;
                        }
                        for (var r = 0; r < regBlocks[b].registers.length; r++) {
                            var reg = regBlocks[b].registers[r];
                            var regName = reg.name.toLowerCase();
                            var dReg = null;
                            if (dBlock.registers && dBlock.registers.length > idx) {
                                // from .csv file
                                dReg = dBlock.registers[idx];
                                dRegName = dReg.name;
                            } else if (dBlock.length && dBlock.length > idx) {
                                // from .json file
                                dReg = dBlock[idx];
                                dRegName = dReg.id;
                            }
                            if (dRegName && dRegName.toLowerCase() === regName) {
                                idx++;
                                reg.value = dReg.value;
                                if (!regPage.isDeferredWrite) {
                                    reg.valueLastWritten = reg.value;
                                    var intValue = gc.utils.getValueFromHexString("" + reg.value);
                                    regPage.writeValueToTargetRegister(intValue, null, b, r);
                                } else {
                                    regPage._registerView.refreshRegValue(b,r);
                                }
                            }
                        }
                        if (idx < dNumRegs) {
                            var msg = "load registers failed: register name mismatch (" + dRegName + " not found.)";
                            templateObj.logMsgAndNotify("warning", msg, false, true);
                            ok = false;
                            break;
                        }
                    }
                    if (regPage.isDeferredWrite){
                        regPage._registerView._deferredAccessCtr++; // update the page
                    }
                    regPage.refreshGrid();
                }
                return ok;
            };

            templateObj.showToastMsg = function(msgType, msg, durationInSeconds) {
                templateObj.$.ti_widget_toast.hideToast();
                templateObj.$.ti_widget_toast.message = msg;
                switch (msgType.toLowerCase()) {
                    case "error":
                        templateObj.$.ti_widget_toast.iconName = "error";
                        templateObj.$.ti_widget_toast.backgroundColor = "red";
                        break;
                    case "warning":
                        templateObj.$.ti_widget_toast.iconName = "warning";
                        templateObj.$.ti_widget_toast.backgroundColor = "orange";
                        break;
                    default:
                        templateObj.$.ti_widget_toast.iconName = "check";
                        templateObj.$.ti_widget_toast.backgroundColor = "teal";
                        break;
                }
                templateObj.$.ti_widget_toast.duration = +durationInSeconds;
                templateObj.$.ti_widget_toast.showToast();
                console.log("toast msg [" + msgType + "]: " + msg);
            };

            templateObj.logMsgAndNotify = function(msgType, msg, showInStatusBar, showInToast) {
                var iconName = templateObj.$.ti_widget_eventlog_view.iconForItem(msgType);
                if (showInStatusBar) {
                    var statusBar = document.querySelector('ti-widget-statusbar');
                    if (statusBar) {
                        statusBar.appStatusText = msg;
                        statusBar.appStatusTooltip = msg;
                        statusBar.setIcon(iconName);
                    }
                }
                if (showInToast) {
                    templateObj.showToastMsg(msgType, msg, 4);
                }
                templateObj.$.ti_widget_eventlog_view.log(msgType, msg);
            };
            if (templateObj.$.ti_widget_label_learnmore) {
                templateObj.$.ti_widget_label_learnmore.addEventListener("click", function (event) {
                    //if the learnmore label is hidden
                    if(templateObj.$.ti_widget_label_learnmore.getAttribute('hidden'))
                    {
                        templateObj.$.ti_widget_label_productname.fontColor = "white";
                        templateObj.$.ti_widget_label_productdesc.fontColor = "white";
                        templateObj.$.ti_widget_label_learnmore.removeAttribute('hidden');
                        templateObj.$.ti_widget_label_showless.setAttribute('hidden', true);
                        templateObj.$.ti_widget_vtab_home.style.backgroundColor = "rgb(20, 140, 156)";
                        templateObj.$.ti_widget_tabcontainer.selectedIndex = 0;
                        templateObj.$.ti_widget_multiimage.selectedIndex = 0;
                    }
                    else
                    {
                        templateObj.$.ti_widget_label_productname.fontColor = "#444";
                        templateObj.$.ti_widget_label_productdesc.fontColor = "#444";
                        templateObj.$.ti_widget_label_learnmore.setAttribute('hidden', true);
                        templateObj.$.ti_widget_label_showless.removeAttribute('hidden');
                        templateObj.$.ti_widget_vtab_home.style.backgroundColor = "white";
                        templateObj.$.ti_widget_tabcontainer.selectedIndex = 1;
                        templateObj.$.ti_widget_multiimage.selectedIndex = 1;
                    }
                });
            }
            if (templateObj.$.ti_widget_label_showless) {
                templateObj.$.ti_widget_label_showless.addEventListener("click", function (event) {
                    //If the showless label is hidden
                    if(templateObj.$.ti_widget_label_showless.getAttribute('hidden'))
                    {
                        templateObj.$.ti_widget_label_productname.fontColor = "#444";
                        templateObj.$.ti_widget_label_productdesc.fontColor = "#444";
                        templateObj.$.ti_widget_label_learnmore.setAttribute('hidden', true);
                        templateObj.$.ti_widget_label_showless.removeAttribute('hidden');
                        templateObj.$.ti_widget_vtab_home.style.backgroundColor = "white";
                        templateObj.$.ti_widget_tabcontainer.selectedIndex = 1;
                        templateObj.$.ti_widget_multiimage.selectedIndex = 1;
                    }
                    else
                    {
                        templateObj.$.ti_widget_label_productname.fontColor = "white";
                        templateObj.$.ti_widget_label_productdesc.fontColor = "white";
                        templateObj.$.ti_widget_label_learnmore.removeAttribute('hidden');
                        templateObj.$.ti_widget_label_showless.setAttribute('hidden', true);
                        templateObj.$.ti_widget_vtab_home.style.backgroundColor = "rgb(20, 140, 156)";
                        templateObj.$.ti_widget_tabcontainer.selectedIndex = 0;
                        templateObj.$.ti_widget_multiimage.selectedIndex = 0;
                    }
                });
            }
            
            /*
            // Code for connect button, removed due to feedback. 
            // Could be implemented more successfully using connectionManager event listener
            //If connect button exists
            if (templateObj.$.ti_widget_button_connect) {
                //Set the label based on initial connection status
                if(gc.connectionManager.status === "disconnected"){
                    ti_widget_button_connect.label = "Disconnect";
                }
                else{
                    ti_widget_button_connect.label = "Connect"
                }
                
                templateObj.$.ti_widget_button_connect.addEventListener("click",function(event){
                    if (gc.connectionManager){
                        if(gc.connectionManager.status === "disconnected"){
                            gc.connectionManager.connect();
                            ti_widget_button_connect.label = "Disconnect";
                        }
                        if(gc.connectionManager.status === "connected"){
                            gc.connectionManager.disconnect();
                            ti_widget_button_connect.label = "Connect"
                        }
                    }
                });
            }*/

            //trying to set the default register read value, not working. 
            /*
            //If register page exists
            if(templateObj.$.ti_widget_register_page){
                //Set default read value to 1s
                ti_widget_register_page._autoReadDroplistValue = "1000";
            }*/
            
        // Handles required synchronization on repeated connections (i.e. starting the GUI again with the board still connected)
            gc.connectionManager.addEventListener("status-changed", function(event){
                if(gc.connectionManager.status === "connected")
                {
                    templateObj.$.ti_widget_label_Firmware.label = templateObj.$.ti_model_register.getCodec().version;
                    if(firstConnectFlag === 0)
                    {
                        ti_widget_register_page._autoReadDroplistValue = Number(1000);
                        firstConnectFlag = 1;
                    }
                }
            });


        }, 1);
        
        


    });
};

templateObj = document.querySelector('#template_obj');
if (templateObj) {
    init();
} else {
    document.addEventListener('DOMContentLoaded', init);
}